# Version 4.12 migration guide
Notifications have been updated to use the latest Firebase Messaging Libraries, which require some additional values to be defined to  work with the deltaDNA Platform. Read on to find out how to upgrade from a previous version of the deltaDNA Android SDK.

## Notifications
### Manifest


#### Firebase Configuration Values
In previous versions, the Firebase Cloud Messaging integration required the following `meta-data` entries in the manifest :
```xml
<application ...>
    ...
    
    <meta-data
        android:name="ddna_application_id"
        android:resource="@string/application_id"/>
    <meta-data
        android:name="ddna_sender_id"
        android:resource="@string/sender_id"/>

</application>
```
From this version on, the following manifest entries must be defined : 
```xml
<application ...>
    ...
    
    <meta-data
        android:name="ddna_application_id"
        android:resource="@string/application_id"/>
    <meta-data
        android:name="ddna_sender_id"
        android:resource="@string/sender_id"/>
    <meta-data
        android:name="ddna_fcm_project_id"
        android:resource="@string/fcm_project_id"/>
    <meta-data
        android:name="ddna_fcm_api_key"
        android:resource="@string/fcm_api_key"/>

</application>
```
The values for `ddna_fcm_project_id` and `ddna_fcm_api_key` can be found in your settings menu on the firebase console for the project - they are the `Project ID` and `Web API Key` respectively.

If using Unity then these values should be configured through the Unity Editor menu item.